## murahatebu : make_cache.rb

require 'base.rb'


module MuraHatebu
  class CacheMaker
    def start( until_date )
      @until_date = until_date

      @hash = {}
      YESTADAY.step( @until_date, -1 ) {|date|
        tmp = DailyData.new( date )
        if tmp.cache_exist?
          @until_date = date + 1
          break
        end
        @hash[date] = tmp
      }
      return if @until_date == TODAY

      @villagers = {}
      Util.load_village_people_file {|name|
        @villagers[name] = Villager.new( name )
      }

      @villagers.each{|name, villager|
        begin
          villager.get_bookmark{|bookmark|
            next if bookmark.time.to_date == TODAY
            if @hash.has_key?( bookmark.time.to_date )
              daily_data = @hash[bookmark.time.to_date]
              unless daily_data.data.any?{|one| one.bookmark_id == bookmark.bookmark_id }
                daily_data.data << bookmark
              end
            end
            Villager::STOP_GET_BOOKMARK if bookmark.time.to_date < @until_date
          }
        rescue => e
          Util.default_error_log( e, "villager = #{name} : #{__LINE__}" )
        end
      }
      @hash.each{|date, daily_data|
        daily_data.save_cache
      }
    end
  end
end
## -- main ---------------------------------------------------------------
## make_cache.rb ˴ؤƤ TODAY ϽʤȤ
if $0 == __FILE__
  MuraHatebu::TODAY = Date.today
  MuraHatebu::YESTADAY = MuraHatebu::TODAY - 1
  until_date = ARGV.empty? ? MuraHatebu::TODAY - 3 : Time.parse( ARGV[0] ).to_date
  MuraHatebu::CacheMaker.new.start( until_date )
end
