## murahatebu : make_data_from_cache.rb
## tool

require 'pstore'

require 'ttrl/matching_list.rb'

require 'base.rb'
require 'analyze_villagers.rb'
require 'nocomment.rb'


module MuraHatebu

  TODAY = Date.today
  YESTADAY = TODAY - 1

  class NoCommentManager
    def recent?( date )
      date <= YESTADAY && date >= ( YESTADAY - NOCOMMENT_DISPLAY_RECENT_DAY + 1 )
    end

    def reset_for_make_data_from_cache
      @entry_hash = {}
      @recent_url = []
      (NOCOMMENT_DISPLAY_RECENT_DAY).times {
        @recent_url << {}
      }
      @done_date = {}
    end

    def add_daily_data_and_recent_update( daily_data )
      if self.recent?( daily_data.date )
        tmp = @updated_url
        @updated_url = @recent_url[(daily_data.date - YESTADAY - 1)]
      end
      self.add_daily_data( daily_data )
      if self.recent?( daily_data.date )
        tmp.update( @updated_url )
        @updated_url = tmp
      end
    end
  end

  nocomment = NoCommentManager.new
  nocomment.reset_for_make_data_from_cache
  analyze = AnalyzeManager.new

  Dir.glob( File.dirname( File.expand_path( __FILE__ ) ) + '/cache/*.dat' ) {|path|
    m = /(20([1-3][0-9])(0[1-9]|1[0-2])(0[1-9]|[12][0-9]|3[01]))\.dat/.match( File.basename( path ) )
    if m
      date = Time.parse( m[1] ).to_date
      daily_data = DailyData.new( date )
      daily_data.raise_if_cache_not_exist
      daily_data.load_cache

      nocomment.add_daily_data_and_recent_update( daily_data )
      analyze.merge_daily_data( daily_data )
    end
  }

  nocomment.save_data
  analyze.save_data

  nocomment.make_updated_entry_html_file
  analyze.make_site_html
end
