## tt web analyze : base.rb

require 'ipaddr'
require 'time'
require 'date'
require 'cgi'
begin
  require 'cgi/html'
rescue LoadError
end

require 'ttrl/utility.rb'


class Date
  def to_continuous_string
    self.strftime( '%Y%m%d' )
  end

  def to_standard_string
    self.strftime( '%Y/%m/%d' )
  end
end

class Time
  def to_date
    Date.new( self.year, self.month, self.day )
  end

  def to_standard_string
    self.strftime( '%Y/%m/%d %H:%M:%S' )
  end
end


module TtWebAnalyze
  VERSION = '1.0.3'

  module Util
    include( TTRL::Utility )
    self.extend( self )

    def to_count_hash( enumerable )
      hash = {}
      enumerable.each{|one|
        key = yield one
        hash[key] = 0 unless hash.has_key?( key )
        hash[key] += 1
      }
      hash
    end
  end

  Tag = Object.new
  Tag.extend( CGI::Html4 )
  Tag.element_init()
  Tag.extend( CGI::HtmlExtension )

  class Access
    def initialize( time )
      @time = time
      @remote_host    = ENV['REMOTE_HOST']
      @remote_address = IPAddr.new( ENV['REMOTE_ADDRESS'] ) if ENV.has_key?( 'REMOTE_ADDRESS' )
      @referer        = ENV['HTTP_REFERER']
      @user_agent     = ENV['HTTP_USER_AGENT']
    end

    attr_reader(
      :time,
      :remote_host,
      :remote_address,
      :referer,
      :user_agent
    )
  end

end
