#! /usr/local/bin/ruby
## tt web analyze : logging.rb

require 'pstore'

Dir.chdir( File.dirname( __FILE__ ) ) {
  require 'base.rb'
}


module TtWebAnalyze
  class Logger
    def initialize
      @now = Time.now
      @database = PStore.new( Util.filename_to_path( "cache/#{@now.to_date.to_continuous_string}.dat" ) )
    end

    def logging
      access = Access.new( @now )
      @database.transaction {
        log = @database.fetch( 'data', [] )
        log << access
        @database['data'] = log
      }
    end
  end
end
TtWebAnalyze::Logger.new.logging
